// Removes TOC based on HTML meta tag
// (&lt;meta name="toc-style" content="Hidden" /&gt;)
$(window).ready(function() {
    var $metaTags = $("meta");
    var tocStyle;
    for (var m = 0; m < $metaTags.length; m++) { 
        if ($metaTags.eq(m).attr("name") === "toc-style") { 
             tocStyle = $metaTags.eq(m).attr("content").toLowerCase(); 
        } 
    }
    if (tocStyle === "hidden") {
         $("#toc, #navigationResizeBar").css("display", "none");
         $("#contentBody").css("left", "1.5em");
         $("#contentBodyInner").css("border", "none");
    }
});

// Improves built-in TOC syncronisation
$(window).ready(function() {
    // Global vars
    var selectedClass = "tree-node-selected";
    var tocLinkSelector = "#navigation #toc a";
    var tocpath = "%3FTocPath%3D";
    var waitTime = 500;

    // Function to identify and update TOC highlighting
    function updateToc() {

        // Functions to get clean link information
        var clean = {
            hash: function(href) {
                if (href.indexOf("#") !== -1) {
                    return href.split("#")[1].split(tocpath)[0];
                } else return null;
            },
            subHash: function(href) {
                if (href.indexOf("#") !== -1) {
                    var splitHref = href.split(tocpath)[0].split("#");
                    return splitHref[splitHref.length - 1];
                } else return null;
            }
        };

        // Function to set highlights in DOM
        function setHighlights($tocLinks, linkIndex) {
            $tocLinks.closest("li").removeClass(selectedClass);
            $tocLinks.eq(linkIndex).closest("li").addClass(selectedClass);
        }

        // Loop to check each TOC link against the URL hash
        // setTimeout gives the TOC time to be populated
        setTimeout(function() {
            var $tocLinks = $(tocLinkSelector);
            var hash = clean.hash(top.location.hash);
            if (hash !== null) {
                var linkIndex;
                for (var tl = 0; tl < $tocLinks.length; tl++) {
                    var href = clean.hash($tocLinks.eq(tl).attr("href"));
                    var subHref = clean.subHash($tocLinks.eq(tl).attr("href"));
                    // Set linkFlag to match top-level TOC link
                    if (hash === href && hash === subHref) {
                        linkIndex = tl;
                    }
                    // If no match, set linkFlag to match sub-level TOC link
                    else if (hash === subHref) {
                        linkIndex = tl;
                    }
                }
                // Remove highlighting from all TOC links except the current one
                setHighlights($tocLinks, linkIndex);
            } else {
                // If no hash is present in the URL, remove highlighting from all TOC links except the first one
                setHighlights($tocLinks, 0);
            }
        }, waitTime);
    }

    // Update the TOC on page load and every time the location is updated
    setTimeout(function() {
        updateToc();
    }, waitTime);
    $(window).on("hashchange", function() {
        updateToc();
    });
});

// Updates webhelps to use UAP styles and scripts
if (window.location.protocol.indexOf("http") != -1) {
    if (window.top.location.href.indexOf("qas.com") != -1 || window.top.location.href.indexOf("staging.dmz.qas") != -1) {
        // Use UAP override styles
        var loc = window.top.location.href;
        var url = loc.split("?")[0];
        url = url + "Resources/Stylesheets/";
        var styleref = document.createElement("link");
        styleref.setAttribute("rel", "stylesheet");
        styleref.setAttribute("type", "text/css");
        styleref.setAttribute("href", url + "UAPWebhelpOverride.css");
        document.getElementsByTagName("head")[0].appendChild(styleref);

        var loc = window.top.location.href;
        var url = loc.split("?")[0];
        url = url + "Resources/";

        var script = document.getElementsByTagName("script");
        for (var i = 0; i < script.length; i++) {
            var scriptname = script[i].src.split("/");
            scriptname = scriptname[scriptname.length - 1];
            if (scriptname.indexOf("jquery") == -1) {
                script[i].src = url + "Scripts/MadCap/" + scriptname;
            }
        }
    }
}