define({"0":{i:0.00758719144651652,u:"../Content/Pro_Web.htm",a:"This guide is for Pro API version 7.64 and later. The Pro API is a suite of functions that you integrate into your own\napplications. Once successfully integrated, Pro takes partial address\ninformation that you type in and returns a full, valid address. Getting Started To get started with Pro API, ...",t:"About Pro API"},"1":{i:0.00804784462681123,u:"../Content/Installing/Installing.htm",a:"Before you install Pro API, you should ensure that you have the following: One Pro API CD; Data CDs/DVDs; Despatch note and or email from Experian containing a valid  licence key . If any of these items are missing, please contact Experian Technical Support. System Requirements The Pro Primary API ...",t:"Installing"},"2":{i:0.0135574546457702,u:"../Content/Installing/Licences.htm",a:"You will receive a licence key for each combination of data and product that you purchase. You will also be sent new licence keys when you renew your data and product licences. Failure to enter a valid licence key means that the product will be unable to use data. \n            If you are running Pro ...",t:"Licences"},"3":{i:0.0184655306641357,u:"../Content/Installing/Testing_Installation.htm",a:"The Primary API is supplied with a simple text-based application, called SingleLineTestHarness64.exe or SingleLineTestHarness32.exe (qs_sl on UNIX), and with sample code. Together these can be used to verify that you have installed Pro API correctly, and to demonstrate some of the API\u0027s key ...",t:"Testing Your Installation"},"4":{i:0.0146168623702052,u:"../Content/Configuring/Configuring.htm",a:"Windows Pro API users can use the  Configuration Editor  to modify most settings relating to Layouts  and  Datasets. For UNIX and advanced Windows configuration, settings need to be configured manually via the  configuration file settings . The Configuration Process When setting up Pro API for the ...",t:"Configuring"},"5":{i:0.0372380372394537,u:"../Content/Configuring/Config_Editor.htm",a:" Configuration Editor Pro API is supplied with a Win32 Configuration Editor. This enables you to do the following: create, edit and manage formatted address layouts for Pro; install and manage Pro datasets; set Pro configuration options; control user access options in Pro. The Configuration Editor ...",t:" Configuration Editor"},"6":{i:0.0117286610316971,u:"../Content/Configuring/Configuration_Settings.htm",a:"Qawserve.ini is known as the \u0027server-side\u0027 configuration file. It contains lists of all the installed datasets and includes the layouts for each available dataset. The settings in this file include: Dataset Installation Search Options Results Output Address Format Intuitive Configuration Error ...",t:"Configuration Settings"},"7":{i:0.143562647000426,u:"../Content/Configuring/Configuration Settings/Dataset_Installation.htm",a:"The file qawserve.ini is used to specify which Primary Sourced datasets are available to Pro API, and the location in which they are installed.  To modify these settings, open the file qawserve.ini in a plain text editor. For Windows, this file can be found in the same directory as the library ...",t:"Dataset Installation Settings"},"8":{i:0.0289133054448971,u:"../Content/Configuring/Configuration Settings/Search_Options.htm",a:"These settings are found in the server ini file, qawserve.ini. {Dataset Code}EngineTimeout The dataset prefix is optional for this setting. Specifying a dataset prefix will override the global setting for that dataset only. Format: {Dataset Code}EngineTimeout={Integer} Default: Purpose: The length ...",t:"Search Options Settings"},"9":{i:0.061654649264714,u:"../Content/Configuring/Configuration Settings/Results.htm",a:"These settings are found in the server ini file, qawserve.ini. They control how Pro API returns and displays multiple results, and can be used to conserve system/network resources. SLMaxMatches Format: SLMaxMatches={ Integer } Default: 1000 Purpose: This defines the maximum number of matches ...",t:"Results Settings"},"10":{i:0.0956935584975295,u:"../Content/Configuring/Configuration Settings/Output_Address_Format.htm",a:"These settings appear in the qawserve.ini file. Each dataset has its own default address format, which conforms to local standards. For example, the default American address contains the house number followed by the street name, town name, state and ZIP code. The default German address, on the other ...",t:"Output Address Format Settings"},"11":{i:0.0160848823905057,u:"../Content/Configuring/Configuration Settings/Intuitive_Configuration.htm",a:"You can configure how your Intuitive suggestions are formatted. IntuitiveSearchMaxPicklist Format: IntuitiveSearchMaxPicklist={Maximum picklist size} Default: 10 Purpose: This defines the maximum picklist size that can be returned by the  Intuitive Search  engine, however, this can be overridden by ...",t:"Intuitive Configuration"},"12":{i:0.061654649264714,u:"../Content/Configuring/Configuration Settings/Error_Logging.htm",a:"Error logging can be used to help diagnose any problems preventing normal\noperation of the Pro API. Problems such as failure to start up the API can be\nsolved from observing the output to the log file. Logging can be activated by modifying configuration settings in the [QADefault]\nsection of the ...",t:"Error Logging Settings"},"13":{i:0.00822711593375531,u:"../Content/Configuring/Configuration Settings/Informational_Prompt.htm",a:"These settings are found in the server ini file, qaworld.ini. Stage1Prompt Format: [identifier]Stage1Prompt={text string} Default: Varies for each dataset. Purpose: This setting and the Stage2MergedTDPrompt setting control the search prompts\nfor Typedown searches. Use this setting to change the ...",t:"Informational Prompt Settings"},"14":{i:0.00758719144651652,u:"../Content/Integrating/Integrating.htm",a:"Integrating the Pro API suite of functions can be achieved using either the  Primary (low-level) API  or the  User Interface API .  If you are running Windows, and the Pro front-end meets your input and output requirements, it is recommended that you integrate the  User Interface API . This is the ...",t:"Integrating"},"15":{i:0.00758719144651652,u:"../Content/Integrating/Data_Types.htm",a:"There are a few Experian-specific data types which appear in the documentation and need some explanation. These types define the parameters that the functions take and values they return. These can be split into three categories: the values that are returned by the functions, the parameters that go ...",t:"Data Types"},"16":{i:0.0112724168888742,u:"../Content/Integrating/Primary_API_Reference.htm",a:"Pseudocode Example of Pro API This section provides an overview of how a program using the Pro API works on a conceptual level. The pseudocode used is programming language independent. The example below uses many of the Pro API functions, so that you can see how they work together. In practice, ...",t:"Primary API Reference"},"17":{i:0.0317730005858608,u:"../Content/Integrating/API_Function_Reference.htm",a:"The Pro Primary API functions are split in to the following groups. General Functions QA_Open: Opens an instance of the API. Opens an instance of the API allowing you to specify the name of the configuration file to use and the section to use within that file. The handle returned from riHandle is ...",t:"API Function Reference"},"18":{i:0.0108117637085795,u:"../Content/Integrating/UI_API_Reference.htm",a:"Handling Client/Server Errors This section is only applicable if you have configured the Pro client to use the Pro server. There are some network communication errors from which it is not always possible to recover. These error conditions are listed below: Server connection full Whilst connecting to ...",t:"User Interface API Reference"},"19":{i:0.00949483426321316,u:"../Content/Integrating/UI_API_Function_Reference.htm",a:" User Interface API Function Reference The User Interface API functions can be split into the following groups: General Functions Starting up and shutting down the API. Search Functions Performing a search, and retrieving picklists of results and formatted addresses. Housekeeping Functions Viewing ...",t:" User Interface API Function Reference"},"20":{i:0.00903418108291844,u:"../Content/Searching/Pro_UI.htm",a:"This is only relevant to Windows users working with the User Interface API. All address searches are performed on the user interface. You can select which searching facility you want to use, which address layout to work with and which dataset to search against. This section covers the ways in which ...",t:"Pro User Interface"},"21":{i:0.00804784462681123,u:"../Content/Searching/Search_Types.htm",a:"Searching with Pro API will vary depending on the requirements of the user and the integration.  Pro API provides  four  different search types which cover a number of searching scenarios. Search types Typedown  searching starts with the most general address element and, once that has been found, ...",t:"Searching with Pro API"},"22":{i:0.0459688755623719,u:"../Content/Searching/Typedown/Typedown.htm",a:"In Typedown searching, users start by typing the most general address element (for example, in the United Kingdom this can be a postcode, county, town or locality) and, once that has been found, they move on to more specific parts of the address. Pro API searches on the string that the user enters, ...",t:"Typedown"},"23":{i:0.0466611803393325,u:"../Content/Searching/Typedown/Search_Examples.htm",a:"Searching For A Residential Address This type of search usually involves three stages. Typically, after an initial search on a place or postal/ZIP code, Pro API will look for street names. Once you have selected the street name that you want, you can enter a property number to return the full ...",t:"Search Examples"},"24":{i:0.0555930912798074,u:"../Content/Searching/Singleline/Singleline.htm",a:"Single Line searching works in the opposite way to Typedown searching: users type in address elements in the order that they appear on an envelope, starting with the most specific (for example, a house number and/or street name) and move onto more general elements (for example, a town or postcode). ...",t:"Single Line"},"25":{i:0.0233387906811578,u:"../Content/Searching/Singleline/Search_Examples.htm",a:"Searching For A Residential Address This type of search usually involves the following stages: Typically, the user enters the address details, in the order that they would appear on an envelope, and performs a search. If more than one possible match is found, the user can select the required address ...",t:"Search Examples"},"26":{i:0.0148839654351713,u:"../Content/Searching/Intuitive/Intuitive.htm",a:"Intuitive searching is only available with the USA, FRX, AUS, AUG, AUE, NZL and NZG datasets. Intuitive searching is designed with simplicity in mind. Address suggestions are displayed as the user is typing in an address. The required address can be selected from the list of suggestions at any ...",t:"Intuitive"},"27":{i:0.0139129184895232,u:"../Content/Searching/Intuitive/Search_Examples.htm",a:"Searching For A Residential Address This type of search usually involves the following stages: Typically, the user enters the address details in the order that they would appear on the envelope. There is no need to click Search; the picklist is automatically updated. If more than one possible match ...",t:"Search Examples"},"28":{i:0.0347113194953155,u:"../Content/Searching/Verification/Verification.htm",a:"Verification Searching is best used to check existing addresses in your applications. It can automatically verify and, if necessary, correct them. The Verification engine can also be used for straightforward address capture scenarios when you do not require the advanced features of Typedown or ...",t:"Verification"},"29":{i:0.0149634337188684,u:"../Content/Searching/Verification/Search_Examples.htm",a:"Verification: Full In this Verification search, the full address is used in the search. Providing the user enters all the information correctly and information exists in the dataset, a full verification should be returned. To search for the residential address, Second Floor Flat, 60 Disraeli Road, ...",t:"Search Examples"},"30":{i:0.0308216365323985,u:"../Content/Searching/Verification/Types_of_match.htm",a:"The Verification engine is used to verify and correct whole addresses. However, the user may not always provide enough information to the Verification engine to enable it to produce a single verifiable match.  An address can be matched to one of a set of verification levels. The verification levels ...",t:"Types of match"},"31":{i:0.0126339932176675,u:"../Content/Searching/Key/Key.htm",a:"Key searching works in a similar way to Single Line searching: the user types \n in the search term, and Pro API returns the address that matches the search \n in the picklist.   Key Searching can only be used with certain datasets that contain a logical reverse search key, for example:   - United ...",t:"Key"},"32":{i:0.0183261481979528,u:"../Content/Searching/Key/Search_Examples.htm",a:"These searches usually involve the following stages: The user enters the key search term and performs a search. Typically the key search term only matches one address, and the full address is returned. If more than one possible match is found, the user can select the required address from a ...",t:"Search Examples"},"33":{i:0.00758719144651652,u:"../Content/Data/Data.htm",a:"For detailed information about our data, view the data guides that accompany your datasets. DataPlus  sets enable users to specify additional information that is returned along with a matched address. Delivery Point Validation (DPV)  is available for USA data. It has been developed by USPS (United ...",t:"Using Our Data"},"34":{i:0.0120146076477283,u:"../Content/Searching/DataPlus.htm",a:"DataPlus enables users to specify that additional information is returned along with a matched address in Pro API. DataPlus information is contained in DataPlus sets. Each piece of information relates to a locality, a postcode, or, when the data requires a higher resolution, to the delivery point ...",t:"Retrieving DataPlus Information"},"35":{i:0.0106464672139499,u:"../Content/Searching/DPV.htm",a:"DPV is only available in the United States. Delivery Point Validation (DPV) has been developed by USPS (United States Postal Service) to help you validate the accuracy of your address information. It enables you to determine whether the actual address exists - all the way down to apartment or suite ...",t:"Delivery Point Validation (DPV)"},"36":{i:0.0166801042336787,u:"../Content/Searching/Alias_Matching.htm",a:"An alias match or a recode message means that although Pro API has\nrecognized the information entered by the user as a possible version of the\naddress, it has replaced it with the official (postally-correct) version from the\nrelevant dataset. For example, an alias match would occur if a user entered ...",t:"Alias Matching"},"37":{i:0.0105676180113264,u:"../Content/Data/Data_Checker.htm",a:"You can check the integrity of Experian data files using quchkn.exe This utility cannot be used with Partner Sourced datasets. You can call quchkn.exe in one of two ways: using the command line, or as a standalone application. Using The Command Line Windows Syntax QUCHKN (filespec) QUCHKN -log -? ...",t:"Data Checker"},"38":{i:0.00804784462681123,u:"../Content/Troubleshooting/Error_Logging.htm",a:"Below is a full list of error codes and their descriptions. Call the system function QAErrorMessage to retrieve the message associated with the returned error code, and QAErrorLevel to ascertain whether the error is serious or a warning. Error Codes Code Message Explanation -1000 qaerr_FATAL Fatal ...",t:"Error Logging"},});